/****************************************************************** 
* Copyright (c) 2003, Mario Hochreiter, Student of 
* Software Engineering at FH-Hagenberg, Austria. 
* Project member of the isac team at the Institute for 
* Software-Technologie, Graz University of Technology, Austria. 
* 
* Use is subject to license terms.
******************************************************************/
package isac.gui.treetable;

import isac.gui.util.CalcModelHierarchy;

import java.io.Serializable;

/**
 * 
 * @author Mario Hochreiter
 * @version 0.1 18/09/2003
 */
public class CalculationModel extends AbstractTreeTableModel 
                              implements Serializable {
   /**
	 * @param root the root element of the <code>CalculationModel</code>
	 */
	public CalculationModel(Object root) {
    super(root);
	}

	/**
	 * @return The root element of the <code>CalculationTree</code>
   * @throws IllegalArgumenException
	 */
	public Object getRoot() {
		if (root instanceof CalcModelHierarchy) {
      return root;         
		}
    throw new IllegalArgumentException("CalculationModel can only handle objects" +
                                       "of type CalcModelHierarchy");
	}
	
	/**
	* @see isac.gui.JTreeTable.TreeTableModel#getColumnCount()
	*/
	public int getColumnCount() {
		return 0;				
	}

	/**
	* @see isac.gui.JTreeTable.TreeTableModel#getColumnName(int)
	*/
	public String getColumnName(int column) {
		return null;
	}

	/**
	* @see isac.gui.JTreeTable.TreeTableModel#getValueAt(java.lang.Object, int)
	*/
	public Object getValueAt(Object node, int column) {
		return null;
	}

	/**
	* @see javax.swing.tree.TreeModel#getChildCount(java.lang.Object)
	*/
	public int getChildCount(Object parent) {
    return 0;							
	}

	/**
	* @see javax.swing.tree.TreeModel#getChild(java.lang.Object, int)
	*/
	public Object getChild(Object parent, int index) {
	  return null;
	}	
}
