(* sml-code for interace

   use"../FE-interface/sml.sml";
   use"FE-interface/sml.sml";
   use"sml.sml";
   *)

fun get_pblID (pt, (p,_):pos') =
    let val p' = par_pblobj pt p
	val (_,pI,_) = get_obj g_spec pt p'
	val (_,(_,oI,_)) = get_obj g_origin pt p'
    in if pI <> e_pblID then Some pI
       else if oI <> e_pblID then Some oI
       else None end;
(*fun get_pblID (pt, (p,_):pos') =
    ((snd3 o (get_obj g_spec pt)) (par_pblobj pt p));*)


(*----------------------vvv--------------------dummies for test*)
val e_tac_ = Tac_ (Pure.thy,"","","");
datatype lOc_ =
  ERror of string         (*after loc_specify, loc_solve*)
| UNsafe of calcstate    (*after loc_specify, loc_solve*)
| Updated of calcstate;   (*after loc_specify, loc_solve*)
fun loc_specify_ m (pt,pos) =
(* val pos = ip;
   *)
    let val (p,_,f,_,s,pt) = specify m pos [] pt;
    in case f of
	   (Error' (Error_ e)) => ERror e
	 | _ => Updated ((pt,p), []) end;

fun loc_solve_ m (pt,pos) =
(* val (m, pos) = ((mI,m), ip);
   
   val (p',_,f,_,s,pt') = solve m pos pt;
   *)
    let val (p,_,f,_,s,pt) = solve m pos pt
    in case f of
	   (Error' (Error_ e)) => ERror e
	 | _ => Updated ((pt,p), []) end;

datatype nxt_ =
	 HElpless  (**)
       | Nexts of calcstate; (**)
(*in sml.sml BELOW!!!
fun nxt_specify_ (pt, pos) =
    let val (_,(p,is),f,tac,s,_) = specify e_tac_ pos [] pt
    in case tac of
	   Empty_Tac(*_*) => HElpless
	 | _ => Nexts ((pt,p), [(tac, e_tac_, (p,is))]) end;
in solve.sml
fun nxt_solve_ (ptp as (pt, pos:pos')) =
    let val (_,(p,is,tac_),f,tac,s,_) = solve ("",e_tac_) pos pt
    in case tac of
	   Empty_Tac(*_*) => (ptp, [])
	 | _ => ((pt,p), [(tac, tac_, (p,is))]) end;*)
(*----------------------^^^--------------------dummies for test*)


fun generate [] ptp = ptp
  | generate ((_, tac_, (p, is))::tacis) (pt, _) = 
    let val (p',_,_,pt') = generate1 (assoc_thy "Isac.thy") tac_ is p pt
    in generate tacis (pt', p') end;

(* val tac = Add_Given "equality (-1 + x = 0)";
   *)

fun applytac tac ((ip, cs as (ptp as (pt, p), tacis)):state) = 
(* val cs as (ptp as (pt, p), _) = ((pt,p), tacis);
   *)
    if p = ([],Res) then ("end-of-calculation", cs:calcstate) else
       if false (*FIXXXXXXXXXXME: remove after test*)
       (*(not o null) tacis andalso ip = p andalso tac = (fst3 o hd ) tacis*)
       then ("ok", (generate tacis ptp, []))(*ev. SEVERAL due to hide*)
       else let val (mI,m) = mk_tac'_ tac;
	    in case applicable_in ip pt m of
		   Notappl e => ("not-applicable", cs)
		 | Appl m =>
(* val Appl m = applicable_in ip pt m;
   *) 
		   let val x = if mI mem specsteps
			       then loc_specify_ m (pt,ip)
			       else loc_solve_ (mI,m) (pt,ip)
		   in case x of 
			  ERror e => ("failure", cs)
			| UNsafe (ptp,_) => ("unsafe-ok", (ptp,[]))
			| Updated (ptp,_) =>(*ev.SEVER.tacs like Begin_Trans*)
			  ("ok", (ptp,[]))  (*for -"-  user to ask ? *)
		   end
	    end;


(*------------------------------------------------------------------
fun init_detail ptp = e_calcstate;(*15.8.03.MISSING-->solve.sml!?*)
(*----------------------------------------------------from solve.sml*)
  | nxt_solv (Detail_Set'(thy', rls, t)) (pt, p) =
    let (*val rls = the (assoc(!ruleset',rls'))
	    handle _ => raise error ("solve: '"^rls'^"' not known");*)
	val thy = assoc_thy thy';
        val (srls, sc, is) = 
	    case rls of
		Rrls {scr=sc as Rfuns {init_state=ii,...},...} => 
		(e_rls, sc, RrlsState (ii t))
	      | Rls {srls=srls,scr=sc as Script s,...} => 
		(srls, sc, ScrState ([(one_scr_arg s,t)], [], 
			       None, e_term, Sundef, true));
	val pt = update_tac pt (fst p) (Detail_Set (id_rls rls));
	val (p,cid,_,pt) = generate1 thy (Begin_Trans' t) is p pt;
	val nx = (tac_2tac o fst3) (next_tac (thy',srls) (pt,p) sc is);
	val aopt = applicable_in p pt nx;
    in case aopt of
	   Notappl s => raise error ("solve Detail_Set: "^s)
	 (* val Appl m = aopt;
	    *)
	 | Appl m => solve ("discardFIXME",m) p pt end
------------------------------------------------------------------*)


(*iterated by nxt_me; there (the resulting) ptp dropped
  ev. calls nxt_solve Apply_Method*)
fun nxt_specify_ (ptp as (pt, pos as (p,p_))) =
(* val (ptp as (pt, (p,p_):pos')) = ptp;
   *)
    let val pblobj as (PblObj{meth,origin=origin as (oris,(dI',pI',mI')),
			      probl,spec=(dI,pI,mI),...}) = get_obj I pt p
    in if just_created pblobj (*by Subproblem*) andalso origin <> e_origin
       then case mI' of
	 ["no_met"] => nxt_specif (Refine_Tacitly pI') (pt, (p,Pbl))
       | _ => nxt_specif (Model_Problem pI') (pt, (p,Pbl))
       else let val cpI = if pI = e_pblID then pI' else pI
		val cmI = if mI = e_metID then mI' else mI
		val {ppc,prls,where_,...} = get_pbt cpI
		val pre = check_preconds thy prls where_ probl
		val pb = foldl and_ (true, map fst pre)
		(*FIXME.WN.8.03:    ~~~~: just check true in itms of pbl/met?*)
		val (_,tac) =
		    nxt_spec Pbl pb oris (dI',pI',mI') (probl,meth) 
			     (ppc,(#ppc o get_met) cmI) (dI,pI,mI);
	    in case tac of
		   Apply_Method mI => nxt_solv (Apply_Method' (mI, None)) ptp
		 | _ => nxt_specif tac ptp end
    end;


(*WN11.9.03--- was only for hide, detail --> dialog ---------
(*
val nxt_me = fn
  : pblID
    -> (ptree * pos') *             : always the latest ovewriting the others
       (tac * tac_ * istate) list   : new tacs found PREpended to others
                                   -"- calcstate (typeinference doesn get it)
       -> detail * detail -> 
       hid ->                       : handles packages of tacs (eg. modeling)
       nxt_                                        
*)
fun nxt_me _ _ _ Hmodel = raise error "nxt_me: not impl. for Hmodel"
  | nxt_me _ _ _ Hspecify = raise error "nxt_me: not impl. for Hspecify"
  | nxt_me _ _ _ Happly = raise error "nxt_me: not impl. for Happly"
(* val ((ptp as (_,(_,p_)), tacis), (hi, de)) = ((ptp, []), (hide, detail));
   *)
  | nxt_me pI (ptp as (_,([],Res)), tacis) _ _ = Nexts (ptp, tacis)
  | nxt_me pI ((ptp as (_,(_,p_)), tacis):calcstate) (hi, de) _(*Hundef,Htac*)=
(* val ((ptp as (_,(_,p_)), tacis), (hi, de)) = ((ptp, []), (hide, detail));
   val ((ptp as (_,(_,p_)), []   ), (hi, de)) = ((ptp, []), (hide, detail));
   *)
    let val x = (if p_ mem [Pbl,Met]
		 then nxt_specify_ ptp else nxt_solve_ ptp)
	    handle _ => (ptp, []) (*e.g. by Add_Given "equality"///*)
    in case x of 
	   (_,[]) => HElpless
	 | (cs as (ptp, (tac,_,_)::_)) => 
	   let val (cs as (ptp, tacis' as (tac,_,_)::_)) = 
		   if is_detail pI tac de then init_detail ptp else cs
	   in case is_hide pI tac hi of
		  Show => Nexts (ptp, tacis' @ tacis)
		| hid => 
		  nxt_me pI (ptp, tacis' @ tacis) (hi, de) hid
	   end
    end;
------------------------------------------------------------------*)

fun nexttac ((ip, (ptp as (_,p as (_,p_)), tacis)):state) =
(* val (ip, (ptp as (_,p as (_,p_)), tacis)) = (ip, cs);
   *)
    let val pIopt = get_pblID ptp;
    in if p = ([],Res) then ("end-of-calculation", []) else
       case tacis of
	   ((tac,_,_)::_) =>
(* val((tac,_,_)::_) = tacis;  
   *) 
	   if ip = p then ("ok", tacis)
	   else (case (if p_ mem [Pbl,Met]
		       then nxt_specify_ ptp else nxt_solve_ ptp)
		      handle _ => (ptp, []) (*e.g. by Add_Given "equality///"*)
		  of (_,[]) => ("helpless", [])
		   | (_, tacis) => ("ok", tacis))
	 | _ => (case pIopt of
		     None => ("no-fmz-spec", [])
		   | Some pI =>
(* val Some pI = pIopt; 
   *)
		     (case (if p_ mem [Pbl,Met]
			    then nxt_specify_ ptp else nxt_solve_ ptp)
			   handle _ => (ptp, []) (*e.g. by Add_Giv"equality/"*)
		       of (_,[]) => ("helpless", [])
			| (_, tacis) => ("ok", tacis)))
    end;

