(* use"../systest/FE-KI-interface.sml";
   use"systest/FE-KI-interface.sml";

   calls of the interface-functions at the SML-toplevel
   *)

 print_depth 3;

"---------------- solve_linear as rootpbl ------------------------";
"---------------- miniscript with mini-subpbl --------------------";
"---------------- root-eq + subpbl: no_met: linear ---------------";

(*------------ set at startup of the KI --------------------------*)
 states:= [];  (*resets all state information in KI               *)
 addUser 1;    (*WILL BE REMOVED IN THE NEXT VERSION !!!!!!!!!!!!!*)
(*----------------------------------------------------------------*)

"---------------- solve_linear as rootpbl ------------------------";
"---------------- solve_linear as rootpbl ------------------------";
"---------------- solve_linear as rootpbl ------------------------";

 CalcTree      (*start of calculation, return No.1*)
     [(["equality (1+-1*2+x=0)", "solveFor x","solutions L"],
       ("Test.thy", 
	["linear","univariate","equation","test"],
	["Test","solve_linear"]))];
 Iterator 1;    (*create an iterator on CalcTree # 1*)
 
 moveRoot 1 1;   (*sets the CalcIterator at the root of calculation No.1*)
 refFormula 1 1; (*dereferences the formula via CalcIterator*)
 
 moveDown 1 1;   (*to the model*)
 fetchProposedTactic 1 1;
 setNextTactic 1 1 (Model_Problem ["linear","univariate","equation","test"]);
 refFormula 1 1; (*gets ModSpec; model is still empty*)

 fetchProposedTactic 1 1;
 setNextTactic 1 1 (Add_Given "equality (1 + -1 * 2 + x = 0)");
 refFormula 1 1; (*equality added*)

 fetchProposedTactic 1 1;
 setNextTactic 1 1 (Add_Given "solveFor x");
 refFormula 1 1;

 fetchProposedTactic 1 1;
 setNextTactic 1 1 (Add_Find "solutions L");
 refFormula 1 1;

 fetchProposedTactic 1 1;
 setNextTactic 1 1 (Specify_Theory "Test.thy");
 refFormula 1 1;

 fetchProposedTactic 1 1;
 setNextTactic 1 1 (Specify_Problem ["linear","univariate","equation","test"]);
 refFormula 1 1;

 fetchProposedTactic 1 1;
 setNextTactic 1 1 (Specify_Method ["Test","solve_linear"]);
 refFormula 1 1;

 fetchProposedTactic 1 1;
 setNextTactic 1 1 (Apply_Method ["Test","solve_linear"]);
 moveDown 1 1;   (*to solve*)
 refFormula 1 1;

 fetchProposedTactic 1 1;
 setNextTactic 1 1 (Rewrite_Set_Inst (["(bdv,x)"], "isolate_bdv"));
 moveDown 1 1;
 refFormula 1 1;

 fetchProposedTactic 1 1;
 setNextTactic 1 1 (Rewrite_Set "Test_simplify");
 moveDown 1 1;
 refFormula 1 1;

 fetchProposedTactic 1 1;
 setNextTactic 1 1 (Check_Postcond ["linear","univariate","equation","test"]);
 moveDown 1 1;
 refFormula 1 1;

 val (ip, ((pt,_),_)) = get_state 1 1;
 val (Form f, tac, asms, safe) = pt_extract (pt, ip);
     (*exception just above means: 'ModSpec' has been returned: error anyway*)
 if term2str f = "[x = 1]" then () else 
 raise error "FE-KI-interface.sml: diff.behav. in solve_linear as rootpbl";


 DEconstrCalcTree 1;


"---------------- miniscript with mini-subpbl --------------------";
"---------------- miniscript with mini-subpbl --------------------";
"---------------- miniscript with mini-subpbl --------------------";

 CalcTree      (*start of calculation, return No.1*)
 [(["equality (x+1=2)", "solveFor x","solutions L"], 
   ("Test.thy", 
    ["sqroot-test","univariate","equation","test"],
    ["Test","squ-equ-test-subpbl1"]))];
 Iterator 1;

 moveRoot 1 1;   (*sets the CalcIterator at the root of calculation No.1*)
 refFormula 1 1; (*dereferences the formula via CalcIterator*)

 moveDown 1 1;   (*to the model*)
 fetchProposedTactic 1 1;
 setNextTactic 1 1 (Model_Problem["sqroot-test","univariate","equation","test"]);
 refFormula 1 1; (*gets ModSpec; model is still empty*)

 fetchProposedTactic 1 1;
 setNextTactic 1 1 (Add_Given "equality (x + 1 = 2)");
 refFormula 1 1;

 fetchProposedTactic 1 1;
 setNextTactic 1 1 (Add_Given "solveFor x");
 refFormula 1 1;

 fetchProposedTactic 1 1;
 setNextTactic 1 1 (Add_Find "solutions L");
 refFormula 1 1;

 fetchProposedTactic 1 1;
 setNextTactic 1 1 (Specify_Theory "Test.thy");
 refFormula 1 1;

 fetchProposedTactic 1 1;
 setNextTactic 1 1 (Specify_Problem 
		      ["sqroot-test","univariate","equation","test"]);
 refFormula 1 1;

 fetchProposedTactic 1 1;
 setNextTactic 1 1 (Specify_Method ["Test","squ-equ-test-subpbl1"]);
 refFormula 1 1;

 fetchProposedTactic 1 1;
 setNextTactic 1 1 (Apply_Method ["Test","squ-equ-test-subpbl1"]);
 moveDown 1 1;   (*to solve*)
 refFormula 1 1;

 fetchProposedTactic 1 1;
 setNextTactic 1 1 (Rewrite_Set "norm_equation");
 moveDown 1 1;
 refFormula 1 1;

 fetchProposedTactic 1 1;
 setNextTactic 1 1 (Rewrite_Set "Test_simplify");
 moveDown 1 1;
 refFormula 1 1;

 fetchProposedTactic 1 1;
 setNextTactic 1 1 (Subproblem ("Test.thy",
			      ["linear","univariate","equation","test"]));
 moveDown 1 1;
 refFormula 1 1;

 fetchProposedTactic 1 1;
 moveDown 1 1;    (*to the model of the subproblem*)
 setNextTactic 1 1 (Add_Given "equality (-1 + x = 0)");
 refFormula 1 1;

 fetchProposedTactic 1 1;
 setNextTactic 1 1 (Add_Given "solveFor x");
 refFormula 1 1;

 fetchProposedTactic 1 1;
 setNextTactic 1 1 (Add_Find "solutions x_i");
 refFormula 1 1;

 fetchProposedTactic 1 1;
 setNextTactic 1 1 (Specify_Theory "Test.thy");
 refFormula 1 1;

 fetchProposedTactic 1 1;
 setNextTactic 1 1 (Specify_Problem ["linear","univariate","equation","test"]);
 refFormula 1 1;

 fetchProposedTactic 1 1;
 setNextTactic 1 1 (Specify_Method ["Test","solve_linear"]);
 refFormula 1 1;

 fetchProposedTactic 1 1;
 setNextTactic 1 1 (Apply_Method ["Test","solve_linear"]);
 moveDown 1 1;   (*to solve*)
 refFormula 1 1;

 fetchProposedTactic 1 1;
 setNextTactic 1 1 (Rewrite_Set_Inst (["(bdv,x)"], "isolate_bdv"));
 moveDown 1 1;
 refFormula 1 1;

 fetchProposedTactic 1 1;
 setNextTactic 1 1 (Rewrite_Set "Test_simplify");
 moveDown 1 1;
 refFormula 1 1;

 fetchProposedTactic 1 1;
 setNextTactic 1 1 (Check_Postcond ["linear","univariate","equation","test"]);
 moveDown 1 1;
 refFormula 1 1;

 fetchProposedTactic 1 1;
 setNextTactic 1 1 (Check_elementwise "Assumptions");
 moveDown 1 1;
 refFormula 1 1;

 val xml = fetchProposedTactic 1 1;
 setNextTactic 1 1 (Check_Postcond 
		      ["sqroot-test","univariate","equation","test"]);
 moveDown 1 1;
 refFormula 1 1;

 val (ip, ((pt,_),_)) = get_state 1 1;
 val (Form f, tac, asms, safe) = pt_extract (pt, ip);
     (*exception just above means: 'ModSpec' has been returned: error anyway*)
 if term2str f = "[x = 1]" then () else 
 raise error "FE-KI-interface.sml: diff.behav. in miniscript with mini-subpb";

 DEconstrCalcTree 1;



"---------------- root-eq + subpbl: no_met: linear ---------------";
"---------------- root-eq + subpbl: no_met: linear ---------------";
"---------------- root-eq + subpbl: no_met: linear ---------------";

 CalcTree      (*start of calculation, return No.1*)
 [(["equality (sqrt(9+4*x)=sqrt x + sqrt(5+x))", "solveFor x","solutions L"],
   ("Test.thy", 
    ["squareroot","univariate","equation","test"],
    ["Test","square_equation"]))];
 Iterator 1;

 DEconstrCalcTree 1;


"-------------------- run scripts for maximum-example ----------------------";
"-------------------- run scripts for maximum-example ----------------------";
"-------------------- run scripts for maximum-example ----------------------";

CalcTree 
[(["fixedValues [r=Arbfix]","maximum A","valuesFor [a,b]",
   "relations [A=a*b, (a/2)^^^2 + (b/2)^^^2 = r^^^2]",
   "relations [A=a*b, (a/2)^^^2 + (b/2)^^^2 = r^^^2]",
   "relations [A=a*b, a/2=r*sin alpha, b/2=r*cos alpha]",
   "boundVariable a","boundVariable b","boundVariable alpha",
   "interval {x::real. 0 <= x & x <= 2*r}",
   "interval {x::real. 0 <= x & x <= 2*r}",
   "interval {x::real. 0 <= x & x <= pi}",
   "errorBound (eps=(0::real))"],
  ("DiffApp.thy", ["maximum_of","function"], ["DiffApp","max_by_calculus"]))];
 Iterator 1;

 DEconstrCalcTree 1;

































