(*
1.9.03,15h

  heaps/polyml-4.1.3_x86-linux> pwd
  /usr/local/Isabelle2002/heaps/polyml-4.1.3_x86-linux
  heaps/polyml-4.1.3_x86-linux> ../../bin/isabelle HOL-Real-Isac

  cd"/netshares/commons/isac/del/Isac";
  use"ROOT.ML";

polyml + Isabelle2003
  /usr/local/bin/isabelle HOL-Complex

RG 
#neue sml-sourcen bersetzen:
  ssh damson
  cd /usr/local/Isabelle2002/heaps/polyml-4.1.3_x86-linux
  mv HOL-Real-Isac HOL-Real-Isac_old
  cp HOL-Real HOL-Real-Isac
  chmod u+w HOL-Real-Isac
  /usr/local/Isabelle2002/bin/isabelle HOL-Real-Isac
  cd"/netshares/studenthomes/rgradisc/CVS-local/isac/src/sml/";
  use"ROOT.ML";
(#mit Strg-C: Endlosschleifen berspringen)
(#ROOT.ML: ab calculate hndisch eingeben)
------
#in scripts starten:
  ssh damson exec /usr/local/Isabelle2002/bin/isabelle HOL-Real-Isac

WN.notebook: SMLNJ
  cd ~/isabelle-smlnj/heaps/smlnj-110_x86-linux/
  sml @SMLload=02-HOL-Real-isac
  cd"~/develop/sml/";
  use"ROOT.ML";

WN.notebook: make HOL-Real
2.10.03: ----> isac/README-nb: re-install isabelle

WN.notebook: HTML fr Isac
  cd ~/develop
  mv sml Isac
  /usr/local/Isabelle2002/bin/isatool usedir -i true HOL-Real /home/neuper/develop/Isac/

WN.notebook: DEVELOP
  /usr/local/Isabelle2002/bin/isabelle HOL-Real
  cd"/home/neuper/develop/sml";
  use"ROOT.ML";

  print_depth 3;
  Compiler.Control.Print.printDepth:=9; (*4 default*)

*)

  print_depth 3; 

(*----- Isabelle2003/src/Pure/library.ML overwritten by later Isa-code*)
fun find_first _ [] = None
  | find_first pred (x :: xs) =
      if pred x then Some x else find_first pred xs;
(*----- Isabelle2003/src/Pure/library.ML overwritten by subsequent Isa-code*)


 use"library.sml";
 use"definitions.sml";
 cd "Scripts";
 	use"term_G.sml";
 	use"calculate.sml";
 	use"rewrite.sml";
 	use"reverse-rew.sml";
 	use_thy"Script";
(*      remove_thy"ListG";
 	use_thy"Scripts/Script";

        Script.thy = {ProtoPure, ..., Real, ListG, Tools, Scrip}
        Isabelle2003  ~~~~~~~~~~~~~~~~~~~~
 	*)
 	use"scrtools.sml";
 	cd ".."; 
 use"globals.sml"; (*skip if re-evaluate Scripts + ME*)
 cd "ME";
 	use"mstools.sml";
 	use"ctree.sml";
 	use"ptyps.sml";
 	use"generate.sml";
 	use"modspec.sml";
 	use"appl.sml";
 	use"script.sml";
 	use"solve.sml"; 
 	cd ".."; 
 "******* build KI complete *******";
 (*-----------------vvv-delete!*)
 use"DG-ME-states.sml";
 cd "DG";
 	use"dialog.sml";        
 	cd ".."; 
 use"stdin-out.sml";
 (*-----------------^^^-delete!*)
 use"states";
 cd "xmlsrc";
 	use"mathml.sml";
 	use"datatypes.sml";        
 	use"pbl-met-hierarchy.sml";      
 	use"interface-xml.sml";
 	cd "..";
 cd"FE-interface";
 	use"messages.sml";
 	use"sml.sml";
 	use"interface.sml";
 	cd "..";
 use"print_exn_G.sml";
 "******* build KI & XML-interface complete *******";
 
 cd "IsacKnowledge";
 	use_thy"Isac";
 (*     remove_thy"Typefix";
 	remove_thy"Descript";
 	use_thy"IsacKnowledge/Isac";
	use_thy"Isac";

        Isac.thy = {ProtoPure, ..., Real, ListG, Tools, Script, ///see above

        Typefix, Float, ComplexI, Descript, Atools, Equation, Poly,
        LinEq, Root, RootEq, Rational, RatEq, RootRat, RootRatEq, PolyEq, 
	Vect, Calculus, Trig, LogExp, Diff, DiffApp, Test, Isac}
*)
 	cd "../";
 "******* build KI & XML complete, knowledge added *******";
 
 (* export of knowledge to xml
    > pwd();
    val it = "/home/neuper/develop/sml" : string
 pbl_hierarchy2file "../xml/pbl/";
 pbls2file "../xml/pbl/";
 met_hierarchy2file "../xml/met/";
 mets2file "../xml/met/";
 "******* build ME & DG complete, knowledge + XML added *******";
 *)
 
val me=meNEW; (*##########################################################*) 
 cd"kbtest";
 	use"complex.sml";
 	use"diff.sml";
 	use"diffapp.sml";  (*meNEW: fmz <> []: nxt <> Add_Relation (a/2)^2..*)
 	use"float.sml";
      (*use"inssort.sml"; problems with recdef in Isabelle2002*)
 	use"logexp.sml";
 	use"poly.sml";     (*TODO //?*)
 	use"polyeq.sml";   (*TODO 31.b, n1., 44.a, 1.a~, 1.b (all'expanded')WN
 			     ? also check others without check 'diff.behav.'*)
 	use"rateq.sml";    (*TODO //?  8.9.03: meOLD instead meNEW !!!*)
 	use"rational.sml"; (*TODO add_fractions_p throws overflow-exn      WN*)
 	use"rlang.sml";    (*WN.12.6.03: for TODOs search 'writeln', 
 			     for simplification search MG 
 		 erls:       98a(1) 104a(1) 104a(2) 68a *)
 	use"root.sml";
 	use"rooteq.sml";   (*TODO //?*)
 	use"rootrateq.sml";(*TODO //?*)
 	use"termorder.sml";
 	use"trig.sml";
 	use"vect.sml";                
 	"******* kbtests complete *******";
 	cd "../";

 cd "systest";
 (*+ check kbtest/diffapp.sml for additional items in met-model*)
 	use"calculate.sml";
val me = meOLD;
        use"details.sml"; (*can notyet ackn. 'Rewrite_Set "cancel"' *)
val me = meNEW;
 	use"root-equ.sml"; 
 	use"script.sml";   
     (* use"script_if.sml";   missing: is_rootequation_in*)
 	use"scriptnew.sml";     
val me = meOLD;
 	use"refine.sml";	       
val me = meNEW;
 	use"subp-rooteq.sml";   
      (*use"FE-KE.sml"; no update after dropping 'errorBound' 5.03*)
 	use"list_rls.sml"; 
 	use"FE-KI-interface.sml";     
 	(**)		       
      (*use"testdaten.sml"; no update after dropping 'errorBound'*)    
 	proofs:= []; dials:=([],[],[]); 
 	"******* systests complete *******";
 	cd "../";
(*
  print_depth 3; 
  Compiler.xControl.Print.printDepth:=15; (*4 default*)
  Compiler.Control.Print.printDepth:=9; (*4 default*)
  Compiler.Control.Print.printDepth:=5; (*4 default*)
  Compiler.Control.Print.printDepth:=4; (*4 default*)

*)
 states:=[]; (*all calcs into user 1: *)addUser 1;

